#
# C
#
require 'find'

require 'datedata'
require 'ftp'

#
# CNX
#
class Main
	Usage = [
		"Usage: #{__FILE__} ConfigFile",
		"Example: ruby #{__FILE__} config.ini",
		"",
		"upftp.rb - XVꂽt@CQFTPɃAbv[h܂B",
		"ɐݒt@Cw肵܂B",
	]

	# 
	#
	def initialize(argv)
		config_file = argv.shift
		unless config_file
			puts Usage
			exit
		end
		
		self.class.module_eval do				# ݒt@Cǂݍ
			eval File::open(config_file) {|fp| fp.read}
		end

		@date_data = DateData.new(Datefile)		# XV
		@transmode = true						# FTP]sH
		@ftp = Ftp.new(Server, Textfile)
	end

	# C
	#
	def run
		unless @date_data.read_file				# XVǂݍ
			puts "XVf[^łB"
			print "FTP]s܂H(y/n): "
			@transmode = (/^y/i =~ gets) ? true : false
		end

		# ]Ώۂ̃t@CW߂
		files = []
		Dirlist.each {|dirlist|
			files.concat search_files(dirlist);
		}

		if files.empty?
			puts "]Ώۂ̃t@C܂łB"
			return
		else
			puts "]Ώۂ̃t@C #{files.size}܂B"
		end

		upload_files(files)
		@date_data.write_file				# XV
	end

	# ]Ώۂ̃t@C
	#  [[Jt@C, [gpX] ̔zԂ
	def search_files (dirlist)
		files = []
		Find.find(dirlist[:localdir]) {|file|
			next unless FileTest.file?(file)	# t@CȊO͑ΏۊO

			# LimitFilterɈΏۊO
			next if dirlist[:limitfilter].any? {|filter|
				file.index(filter)
			}

			next unless @date_data.update?(file)	# XVĂȂΏۊO
			
			# [gpX߂
			rpath = File.dirname( file.sub(dirlist[:localdir], dirlist[:remotedir]) )
			files.push( [file, rpath] )
		}
		files
	end
	
	# t@CAbv[h
	#
	def upload_files(files)
		if @transmode
			begin
				@ftp.open
				files.each { |file, rpath|
					begin
						@ftp.chdir(rpath)
					rescue
						puts $!
						@ftp.mkdir(rpath)
						@ftp.chdir(rpath)
					end
					@ftp.put(file)
					@date_data.update(file)
				}
			ensure
				@ftp.close
			end
		else
			files.each {|file, rpath| @date_data.update(file)}
		end
	end
end
